<id>
Anguz:FuseBox
</id>

<version>
1.22
</version>

<edit file>
index.php
</edit file>

<search for>
	// Is the forum in maintenance mode? (doesn't apply to administrators.)
</search for>

<add before>
	// Fuse Box.
	if (!empty($modSettings['fuseBox']))
	{
		if ($maintenance == 0 && !empty($modSettings['fuseBox_forum']) && blownFuse('forum'))
		{
			global $mmessage, $txt;
			$mmessage = $txt['fuseBox_msg1'];
			$maintenance = 1;
		}

		if ($maintenance == 0 && !empty($_REQUEST['action']))
		{
			if (($_REQUEST['action'] == 'search' || $_REQUEST['action'] == 'search2') && !empty($modSettings['fuseBox_search']) && blownFuse('search'))
				fatal_lang_error('fuseBox_msg2', false);
			elseif ($_REQUEST['action'] == 'unread' && isset($_REQUEST['all']) && !empty($modSettings['fuseBox_unreadAll']) && blownFuse('unreadAll'))
				unset($_REQUEST['all']);
			elseif ($_REQUEST['action'] == 'stats' && !empty($modSettings['fuseBox_stats']) && blownFuse('stats'))
				fatal_lang_error('fuseBox_msg3', false);
		}
	}

</add before>

<edit file>
$sourcedir/Load.php
</edit file>

<search for>
	if (!empty($modSettings['autoOptMaxOnline']))
</search for>

<add before>
	// Fuse Box.
	if (!empty($modSettings['fuseBox']) && !empty($modSettings['fuseBox_autoOptDb']) && blownFuse('autoOptDatabase'))
		return;

</add before>

<edit file>
$sourcedir/Subs.php
</edit file>

<search for>
// Do a query.  Takes care of errors too.
</search for>

<add before>
// Fuse Box.
function blownFuse($fuse)
{
	global $modSettings;
	static $update = true;
	if ($update)
	{
		$time = time();
		if (($time - $modSettings['fuseBox_lastAvgTime']) > 60)
		{
			$load = preg_match('~average: ([\d\.]+)~', @shell_exec('uptime'), $match) == 1 ? (float) $match[1] : false;
			updateSettings(array('fuseBox_lastAvgLoad' => $load, 'fuseBox_lastAvgTime' => $time));
			$modSettings['fuseBox_lastAvgLoad'] = $load;
			$modSettings['fuseBox_lastAvgTime'] = $time;
		}
		$update = false;
	}
	return ($modSettings['fuseBox_lastAvgLoad'] !== false && $modSettings['fuseBox_lastAvgLoad'] > (float) $modSettings['fuseBox_' . $fuse] ? true : false);
}

</add before>

<edit file>
$sourcedir/ModSettings.php
</edit file>

<search for>
		array('heading', &$txt['mods_cat_layout']),
</search for>

<add before>
		array('rule'),
			// Fuse Box.
			array('check', 'fuseBox'),
			array('float', 'fuseBox_forum', 5),
			array('float', 'fuseBox_search', 5),
			array('float', 'fuseBox_unreadAll', 5),
			array('float', 'fuseBox_stats', 5),
			array('float', 'fuseBox_autoOptDb', 5),
</add before>

<edit file>
$languagedir/Modifications.english.php
</edit file>

<search for>
// Version: 1.0 RC2; Modifications
</search for>

<add after>

// Fuse Box.
$txt['fuseBox'] = '<b>Fuse Box</b>';
$txt['fuseBox_forum'] = 'Forum';
$txt['fuseBox_msg1'] = 'Sorry, the forum has been temporarily closed due to high stress on the server. Please come back later.';
$txt['fuseBox_search'] = 'Search';
$txt['fuseBox_msg2'] = 'Sorry, the search functionality has been temporarily disabled due to high stress on the server. Please try again later.';
$txt['fuseBox_unreadAll'] = 'Unread All';
$txt['fuseBox_stats'] = 'Statistics Center';
$txt['fuseBox_msg3'] = 'Sorry, the Statistics Center has been temporarily disabled due to high stress on the server. Please try again later.';
$txt['fuseBox_autoOptDb'] = 'Auto Optimize Database';
</add after>

<edit file>
$languagedir/Help.english.php
</edit file>

<search for>
$helptxt = array();
</search for>

<add after>

$helptxt['fuseBox'] = 'This will let you set maximum acceptable server loads for the listed items, helping you prevent further overload.';
$helptxt['fuseBox_forum'] = 'When the server load goes over the limit set for this item, the forum will be put in Maintenance Mode until the load comes back down. (0 = no limit)';
$helptxt['fuseBox_search'] = 'When the server load goes over the limit set for this item, the search feature will be disabled until the load comes back down. (0 = no limit)';
$helptxt['fuseBox_unreadAll'] = 'When the server load goes over the limit set for this item, Unread All will behave as Unread only, without the All, until the load comes back down. (0 = no limit)';
$helptxt['fuseBox_stats'] = 'When the server load goes over the limit set for this item, the Statistics Center will be disabled until the load comes back down. (0 = no limit)';
$helptxt['fuseBox_autoOptDb'] = 'When the server load goes over the limit set for this item, the Auto Optimize Database functionality will be disabled until the load comes back down. (0 = no limit)';
</add after>
